;***** LED Fader version 2. For Mega16 running 16 MHz
;      Copyright (c) 2003, Mikael Ejberg Pedersen
;      This program is free for personal use.
;
;	Version 2.01


.include "m16def.inc"


; r0-r1 reserved for mul results
.def	PWMCount=r2	; Free running 8-bit counter for PWM generator
.def	ScriptCount=r3	; ScriptNumber counter
.def	w1	=r16	; General purpose working register
.def	w2	=r17	; General purpose working register
.def	w3	=r18	; General purpose working register
.def	w4	=r19	; General purpose working register
.def	w5	=r20	; General purpose working register
.def	w6	=r21	; General purpose working register
.def	Flags	=r22
; r26-31 reserved to X, Y and Z registers


.cseg

.org	0
	jmp	RESET		;Use rjmp for Mega8 !
.org	OC1Aaddr
	jmp	PWM_OC1A_int	;Use rjmp for Mega8 !


.include "pwm.inc"
.include "ledrec.inc"
.include "scr_cmd.inc"
.include "scripts.inc"


.cseg

;**** Application init
RESET:
	ldi	w1,low(RAMEND)
	out	SPL,w1			;Init stackpointer
	ldi	w1,high(RAMEND)
	out	SPH,w1
	
	call	PWM_Init1		;Clear PWM tables. Init PWM ports
	call	LedRec_Init		;Clear LedRec table
	call	Script_Init		;Clear script table. Start first script	
	clr	Flags
	call	PWM_Init2_Timer1setup	;Setup Timer1 (incl. OVF1 interrupt)
	sei				;Enable interrupts

Mainloop:
	sbrs	Flags,0
	rjmp	Mainloop
	cbr	Flags,1
	call	PWMToOutput_WXY
	call	RunScripts_WXYZ
	call	UpdateLedRecs_WXYZ
	rjmp	Mainloop
	
